<?
//////////////////////////////////////////////////////////////////////////////
function mysiteAddProject($name, $link, $description, $categoryID) {
  global $mysiteProjects;
  
  $name = sql_prepare_str($name, false);
  $link = sql_prepare_str($link, false);
  $description = sql_prepare_str($description, false);
  $dirName = MYSITE_FILES_DIR . $name;

  $res = true;
  if (sql_query("INSERT INTO $mysiteProjects (category_id, creation_time, modification_time, name, link, description) VALUES ($categoryID, UNIX_TIMESTAMP(), UNIX_TIMESTAMP(), '$name', '$link', '$description')")) {
    if (!is_dir($dirName)) {
      if (!mkdir($dirName, MYSITE_FILES_DIR_PERMISSIONS)) {
        sql_query("DELETE FROM $mysiteProjects WHERE id = LAST_INSERT_ID()");
        $res = false;
      }
    }
  }

  return $res;
}

//////////////////////////////////////////////////////////////////////////////
function mysiteModifyProject($id, $name, $link, $description, $categoryID) {
  global $mysiteProjects;
  
  $name = sql_prepare_str($name, false);
  $link = sql_prepare_str($link, false);
  $description = sql_prepare_str($description, false);

  return sql_query("UPDATE $mysiteProjects SET category_id = $categoryID, modification_time = UNIX_TIMESTAMP(), name = '$name', link = '$link', description = '$description' WHERE id = $id");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteTouchProject($id) {
  global $mysiteProjects;
  
  return sql_query("UPDATE $mysiteProjects SET modification_time = UNIX_TIMESTAMP() WHERE id = $id");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteAddCategory($name) {
  global $mysiteProjectsCategories;

  $name = sql_prepare_str($name, true);
  
  return sql_query("INSERT INTO $mysiteProjectsCategories (name) VALUES ('$name')");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteModifyCategory($id, $name) {
  global $mysiteProjectsCategories;

  $name = sql_prepare_str($name, true);
  
  return sql_query("UPDATE $mysiteProjectsCategories SET name = '$name' WHERE id = $id");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteDeleteCategory($id) {
  global $mysiteProjectsCategories;

  return sql_query("DELETE FROM $mysiteProjectsCategories WHERE id = $id");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteAddUploadedFile($projectID, $fileName) {
  if (is_uploaded_file($_FILES[$fileName]['tmp_name'])) {
    $file = MYSITE_FILES_DIR . renderProjectName($projectID) . '/' . $_FILES[$fileName]['name'];
    if (file_exists($file)) {
      unlink($file);
    }
    move_uploaded_file($_FILES[$fileName]['tmp_name'], $file);
    chmod($file, MYSITE_FILES_DIR_PERMISSIONS);    
    mysiteTouchProject($id);
  }
}

//////////////////////////////////////////////////////////////////////////////
function mysiteDeleteFile($projectID, $fileName) {
  return unlink(MYSITE_FILES_DIR . renderProjectName($projectID) . '/' . $fileName);
}

//////////////////////////////////////////////////////////////////////////////
function mysiteCreateTables() {
  global $mysiteLogin, $mysiteProjects, $mysiteProjectsCategories;

  $mysiteLogin->createTables();

  sql_query("CREATE TABLE $mysiteProjects (id mediumint(8) unsigned NOT NULL auto_increment,
                                           category_id mediumint(8) unsigned NOT NULL default '0',
                                           creation_time int(10) unsigned NOT NULL default '0',
                                           modification_time int(10) unsigned NOT NULL default '0',
                                           name varchar(255) NOT NULL default '',
                                           link varchar(255) NOT NULL default '',
                                           description text NOT NULL,
                                           PRIMARY KEY  (id)) TYPE=MyISAM");
                                           
  sql_query("CREATE TABLE $mysiteProjectsCategories (id mediumint(8) unsigned NOT NULL auto_increment,
                                                     name varchar(255) NOT NULL default '',
                                                     PRIMARY KEY  (id)) TYPE=MyISAM");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteIsInstalled() {
  global $mysiteProjects;

  return sql_query("SELECT COUNT(*) FROM $mysiteProjects");
}

//////////////////////////////////////////////////////////////////////////////
function mysiteInstall($loginName, $loginHashPassword) {
  global $mysiteLogin;

  mysiteCreateTables();
  $mysiteLogin->addUser($loginName, $loginHashPassword);
}
?>
